SystemOrganization addCategory: #Ranking!

Object subclass: #Ranking
	instanceVariableNames: 'attenders sortDescriptor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ranking'!

!Ranking methodsFor: 'accessing' stamp: 'HwaJong 2/16/2013 14:03'!
attenders: anArray 
	attenders := anArray ! !

!Ranking methodsFor: 'self evaluating' stamp: 'HwaJong 4/14/2013 19:53'!
attendersOfRankOrder: anInteger 
	^(self sortedRanks select: [:each| each rankOrder = anInteger ]) collect: [:each| each attender] ! !

!Ranking methodsFor: 'accessing' stamp: 'HwaJong 2/16/2013 14:04'!
sortDescriptor: anSortDescriptor 
	sortDescriptor := anSortDescriptor ! !

!Ranking methodsFor: 'self evaluating' stamp: 'HwaJong 2/16/2013 22:43'!
sortedRanks

	|sortedAttender sortedRanks rank|
	attenders isEmpty ifTrue: [^{}].
	sortedAttender := attenders asSortedCollection: sortDescriptor.
	sortedRanks := sortedAttender collect: [:each| RankingEntry new attender: each ].
	
	rank := 1.
	sortedRanks first rankOrder: 1.

	2 to: sortedRanks size do: [:index|
		|prior unrankedYet|
		prior := sortedRanks at: index-1.
		unrankedYet := sortedRanks at: index.
		sortDescriptor
			object1: (prior attender) 
			object2: (unrankedYet attender) 
			ifSame: [unrankedYet rankOrder: prior rankOrder]
			ifInOrder: [unrankedYet rankOrder: index]
			ifNotInOrder: [unrankedYet rankOrder: index]].
	^sortedRanks ! !

Object subclass: #RankingEntry
	instanceVariableNames: 'rankOrder attender'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ranking'!

!RankingEntry methodsFor: 'accessing' stamp: 'HwaJong 2/16/2013 12:13'!
attender
	^ attender! !

!RankingEntry methodsFor: 'accessing' stamp: 'HwaJong 2/16/2013 12:10'!
attender: anObject
	attender := anObject 
	! !

!RankingEntry methodsFor: 'accessing' stamp: 'HwaJong 2/16/2013 12:38'!
rankOrder
	^ rankOrder! !

!RankingEntry methodsFor: 'accessing' stamp: 'HwaJong 2/16/2013 12:10'!
rankOrder: anInteger 
	rankOrder := anInteger! !

TestCase subclass: #RankingTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ranking'!

!RankingTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 2/16/2013 14:30'!
test12312312
	|r|
	r := Ranking new.
	r attenders: #(1 2 3 1 2 3 1 2).
	r sortDescriptor: (UnarySortDescriptor descendingBy: #yourself).
	self assert: ((r sortedRanks collect: [:each| {each rankOrder. each attender} ]) asArray)
	equals: #((1 3) (1 3) (3 2) (3 2) (3 2) (6 1) (6 1) (6 1))! !

!RankingTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/14/2013 19:47'!
testRank1
	|r|
	r := Ranking new.
	r attenders: #(1 2 3 1 2 3 1 2).
	r sortDescriptor: (UnarySortDescriptor descendingBy: #yourself).
	self assert: ((r attendersOfRankOrder: 1) asArray)
	equals: #(3 3)! !

!RankingTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/14/2013 19:48'!
testRank2
	|r|
	r := Ranking new.
	r attenders: #(1 2 3 1 2 3 1 2).
	r sortDescriptor: (UnarySortDescriptor descendingBy: #yourself).
	self assert: ((r attendersOfRankOrder: 2) asArray)
	equals: #()! !

!RankingTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 4/14/2013 19:48'!
testRank3
	|r|
	r := Ranking new.
	r attenders: #(1 2 3 1 2 3 1 2).
	r sortDescriptor: (UnarySortDescriptor descendingBy: #yourself).
	self assert: ((r attendersOfRankOrder: 3) asArray)
	equals: #(2 2 2)! !
